<?php
namespace Teknisa\CTB\Controllers;

use Teknisa\CTB\Services\Ctb00001RelatorioFaturamentoCustomizavelService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;

class Ctb00001RelatorioFaturamentoCustomizavelController extends \Teknisa\CTB\Controllers\TeknisaCrud {

    protected $relatorioFaturamentoCustomizavelService;

    public function __construct($relatorioFaturamentoCustomizavelService) {
        $this->relatorioFaturamentoCustomizavelService = $relatorioFaturamentoCustomizavelService;
    }
    
    public function buscaDadosFaturamento(DTO\Request\Filter $request, DTO\Response $response) {
        $row = $this->getFilterArray($request);
        $dataSet = $this->relatorioFaturamentoCustomizavelService->buscaDadosFaturamento($row);
        $dataSet = new DataSet('buscaDadosFaturamento', $dataSet);
        $response->addDataSet($dataSet);
        
    }
    
    private function getFilterArray($request) {
        $filter = array();
        $conditions = $request->getFilterCriteria()->getConditions();
        foreach ($conditions as $condition) {
            $filter[$condition["columnName"]] = $condition["value"];
        }
        return $filter;
    }
}