<?php
namespace Teknisa\CTB\Modules\Saldos\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ctb44200RazaoGerencialService {

    protected $entityManager;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Environment $environment,NewCode $newCode) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->newCode = $newCode;
    }

    public function geraRazaoGerencialNovo($row) {
        try{

            foreach($row as $params){

                switch ($params["name"]) {
                    case "DTINICIAL":
                        $datainic = $params["value"];
                    break;
                    case "DTFINAL":
                        $datafin =  $params["value"];
                    break;
                    case "CDCONTINI":
                        $cdcontini = $params["value"];
                    break;
                    case "CDCONTFIN":
                        $cdcontfin = $params["value"];
                    break;
                }
            }

            $cdempresa  = isset($row['CDEMPRESA'])  ? implode('_', $row['CDEMPRESA'])  :'T';
            $cdregional = isset($row['CDREGIONAL']) ? implode('_', $row['CDREGIONAL']) :'T';
            $cdfilial   = isset($row['CDFILIAL'])   ? implode('_', $row['CDFILIAL'])   :'T';
            $cdcentcust = isset($row['CDCENTCUST']) ? implode('_', $row['CDCENTCUST']) :'T';

            $nrorg = $this->environment->getNrOrgTrab();
            $nrctbtemp = $this->newCode->getCodeByTableName('CTBTEMP', $nrorg, 1, 6);

            $this->execProcGeraRazaoGerTemp(
               $cdempresa, $datainic, $datafin, $nrctbtemp, $cdregional, $cdfilial, $cdcentcust, $cdcontini, $cdcontfin
            );
        } catch (\Exception $e) {
            throw $e;
        }

        return $nrctbtemp;
    }

    public function execProcGeraRazaoGerTemp(
        $cdempresa, $datainic, $datafin, $nrctbtemp, $cdregional, $cdfilial, $cdcentcust, $cdcontini, $cdcontfin
    ){

        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_RAZAOGER_SAP');
        $procedure->addParam(new Param('P_CDEMPRESA'  , Param::PARAM_INPUT , $cdempresa  , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL'   , Param::PARAM_INPUT , $datainic   , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL'    , Param::PARAM_INPUT , $datafin    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRCTBTEMP'  , Param::PARAM_INPUT , $nrctbtemp  , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDAREAGERE' , Param::PARAM_INPUT , $cdregional , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIAL'   , Param::PARAM_INPUT , $cdfilial   , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCENTCUST' , Param::PARAM_INPUT , $cdcentcust , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONTINI'  , Param::PARAM_INPUT , $cdcontini  , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONTFIM'  , Param::PARAM_INPUT , $cdcontfin  , Param::PARAM_TYPE_STR));
        $procedure->execute();
    }

}