<?php
namespace Teknisa\CTB\Services;

use Teknisa\Model\Geral\Entities\Filial;
use Teknisa\CTB\Factories\Ger06300CentroDeCustoFactory;
use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;

class Ger06300CentroDeCustoService {

	protected $environment;
	protected $entityManager;
	protected $Ger06300CentroDeCustoFactory;

	public function __construct(Environment $environment, \Doctrine\ORM\EntityManager $entityManager, Ger06300CentroDeCustoFactory $Ger06300CentroDeCustoFactory) {
		$this->environment = $environment;
		$this->entityManager = $entityManager;
		$this->Ger06300CentroDeCustoFactory = $Ger06300CentroDeCustoFactory;
	}

	public function validatePadraoOnDelete($row) {
		if ($row["CENTCUSTPADRAO"] == "S") {
			$this->entityManager->beginTransaction();
			try {
				$filial = $this->Ger06300CentroDeCustoFactory->buscaFilial($this->environment->getNrOrgTrab(), $row["CDFILIAL"]);
				$filial->setCdcentcust(null);
				// $filial->persist();
				$this->entityManager->flush();
				$this->entityManager->commit();
			} catch (\Exception $e) {
				$this->entityManager->rollback();
				throw new \Exception("Erro ao validar Centro de Custo Padrão!", 500);
			}
		}
	}

	public function validatePadraoOnSave($row) {
		if ($row["CENTCUSTPADRAO"] == "S") {
			$this->entityManager->beginTransaction();
			try {
				$filial = $this->Ger06300CentroDeCustoFactory->buscaFilial($this->environment->getNrOrgTrab(), $row["CDFILIAL"]);
				$filial->setCdcentcust($row["CDCENTCUST"]);
				// $filial->persist();
				$this->entityManager->flush();
				$this->entityManager->commit();
			} catch (\Exception $e) {
				$this->entityManager->rollback();
				throw new \Exception("Erro ao validar Centro de Custo Padrão!".$e, 500);
			}
		}
	}
}